package vishnu.testvis.dendro;

import java.util.*;
import vishnu.testvis.object.*;
import vishnu.datablock.*;


public class ClusterArray
{
    Vector contents;
    
    ClusterArray(DataManager dm, Vector indices)
    {
	int i;
	
	contents = new Vector();

	// num_of_clusters = number of docs
	for (i = 0; i < indices.size(); i++)
	    {
		int id = ((Integer)indices.elementAt(i)).intValue();
		Cluster c = new Cluster(i, null, null, null, 0, 1);
		Vector docIndexVector = new Vector();
		docIndexVector.addElement(new Integer(id));
		c.setDocVect(docIndexVector);
		
		Vector docObjVector = new Vector();
		DocObj docObj = dm.getDocObjAt(id);
		docObjVector.addElement(docObj);
		c.setDocObjVect(docObjVector);    
		
		DataBlock data = dm.getDataBlock();
		int[] wordFreqs = new int[data.words.length];
		for(int d=0; d < data.words.length; d++) wordFreqs[d]=0;
		
		SparseNode row = data.matrix.getRow(id);
		
		while( row!= null)
		    {
			wordFreqs[row.getColumn()]++;
			row = row.getNext();
		    }
		c.setWordFreq(wordFreqs);
		
    		contents.addElement(c);
		
		// i.e. id = i, similarity between kids = 0, #items = 1
	    }
    }
    
    
}




